import { ModelDefinition, MODEL_DEFINITION_VALIDATION_CHECK_ERROR_TYPE } from "../../../shared/src/types";
export declare const WARNING_DEPRECATED_MODEL_DEFINITION_FN: string;
export declare const WARNING_UNDEFINED_PADDING: string;
export declare const WARNING_PROGRESS_WITHOUT_PATCH_SIZE: string;
export declare const ERROR_INVALID_TENSOR_PREDICTED: (shape: number[]) => string;
export declare const ERROR_INVALID_MODEL_PREDICTION: string;
export declare const GET_UNDEFINED_TENSORS_ERROR: Error;
export declare class AbortError extends Error {
    message: string;
}
export declare const ERROR_INVALID_MODEL_TYPE: (modelType: unknown) => string;
export declare const ERROR_MODEL_DEFINITION_BUG = "There is a bug with the upscaler code. Please report this.";
export declare const WARNING_INPUT_SIZE_AND_PATCH_SIZE: string;
export declare const ERROR_WITH_MODEL_INPUT_SHAPE: (inputShape?: unknown) => string;
export declare const GET_INVALID_SHAPED_TENSOR: (shape: number[]) => Error;
export declare const GET_INVALID_PATCH_SIZE: (patchSize: number) => Error;
export declare const GET_INVALID_PATCH_SIZE_AND_PADDING: (patchSize: number, padding: number) => Error;
export declare const GET_WARNING_PATCH_SIZE_INDIVISIBLE_BY_DIVISIBILITY_FACTOR: (patchSize: number, divisibilityFactor: number, upscaledPatchSize: number) => string;
export declare const MODEL_INPUT_SIZE_MUST_BE_SQUARE: Error;
export declare const MODEL_CONFIGURATION_MISSING_PATH_AND_INTERNALS_URL = "https://upscalerjs.com/documentation/troubleshooting#missing-path-and-internals";
export declare const GET_MODEL_CONFIGURATION_MISSING_PATH_AND_INTERNALS: (modelConfiguration?: Partial<ModelDefinition>) => string;
export declare function getModelDefinitionError(error: MODEL_DEFINITION_VALIDATION_CHECK_ERROR_TYPE, modelDefinition?: ModelDefinition): Error;
//# sourceMappingURL=errors-and-warnings.d.ts.map