import { isAborted, } from './utils';
import { isTensor, } from '../../../shared/src/constants';
import { AbortError, } from './errors-and-warnings';
export const makeTick = (tf, signal, awaitNextFrame) => async (result) => {
    if (awaitNextFrame) {
        await tf.nextFrame();
    }
    if (isAborted(signal)) {
        if (Array.isArray(result)) {
            result.forEach(r => r?.dispose());
        }
        else if (isTensor(result)) {
            result.dispose();
        }
        throw new AbortError();
    }
};
