"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getUpscaler = void 0;
var default_model_1 = __importDefault(require("@upscalerjs/default-model"));
var warmup_1 = require("./warmup");
var upscale_1 = require("./upscale");
var model_utils_1 = require("./model-utils");
var DEFAULT_MODEL = default_model_1.default;
function getUpscaler(_a) {
    var tf = _a.tf, getUpscaleOptions = _a.getUpscaleOptions, checkValidEnvironment = _a.checkValidEnvironment, getImageAsTensor = _a.getImageAsTensor, tensorAsBase64 = _a.tensorAsBase64, loadModel = _a.loadModel;
    var Upscaler = (function () {
        function Upscaler(opts) {
            if (opts === void 0) { opts = {}; }
            var _this = this;
            this._abortController = new AbortController();
            this.upscale = this.execute.bind(this);
            this.warmup = function (warmupSizes, options) {
                if (warmupSizes === void 0) { warmupSizes = []; }
                return __awaiter(_this, void 0, void 0, function () {
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4, this.ready];
                            case 1:
                                _a.sent();
                                return [2, (0, warmup_1.cancellableWarmup)(tf, this._model, warmupSizes, options, {
                                        signal: this._abortController.signal,
                                    })];
                        }
                    });
                });
            };
            this.abort = function () {
                _this._abortController.abort();
                _this._abortController = new AbortController();
            };
            this.dispose = function () { return __awaiter(_this, void 0, void 0, function () {
                var _a, model, modelDefinition;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0: return [4, this.ready];
                        case 1:
                            _b.sent();
                            return [4, this._model];
                        case 2:
                            _a = _b.sent(), model = _a.model, modelDefinition = _a.modelDefinition;
                            if (!modelDefinition.teardown) return [3, 4];
                            return [4, modelDefinition.teardown(tf)];
                        case 3:
                            _b.sent();
                            _b.label = 4;
                        case 4:
                            model.dispose();
                            return [2];
                    }
                });
            }); };
            this.getModel = function () { return _this._model; };
            this._opts = __assign({}, opts);
            this._model = loadModel(tf, (0, model_utils_1.getModel)(tf, this._opts.model || DEFAULT_MODEL));
            this.ready = new Promise(function (resolve, reject) {
                _this._model.then(function () { return (0, warmup_1.cancellableWarmup)(tf, _this._model, (_this._opts.warmupSizes || []), undefined, {
                    signal: _this._abortController.signal,
                }); }).then(resolve).catch(reject);
            });
        }
        Upscaler.prototype.execute = function (image, options) {
            return __awaiter(this, void 0, void 0, function () {
                var internals, modelPackage;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            internals = {
                                checkValidEnvironment: checkValidEnvironment,
                                getImageAsTensor: getImageAsTensor,
                                tensorAsBase64: tensorAsBase64,
                            };
                            return [4, this.ready];
                        case 1:
                            _a.sent();
                            return [4, this._model];
                        case 2:
                            modelPackage = _a.sent();
                            return [2, (0, upscale_1.cancellableUpscale)(tf, image, getUpscaleOptions(options), __assign(__assign({}, modelPackage), { signal: this._abortController.signal }), internals)];
                    }
                });
            });
        };
        return Upscaler;
    }());
    ;
    return Upscaler;
}
exports.getUpscaler = getUpscaler;
;
